package beasts;

import java.awt.*;

/**
 * Eggs, can hatch into beasts.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@unsw.edu.au">peteg@unsw.edu.au</A>)
 * @version $Id: Egg.java,v 1.12 2002/02/19 10:33:45 peteg Exp $
 */
class Egg extends Beast {
    static Image image0, image1;
    private boolean age;

    Egg(BeastsWorld beasts, int x, int y) {
	super(beasts, x, y);
	age = false;
    }

    Image getImage() {
	return age ? image1 : image0;
    }

    int points() {
	return 1;
    }

    public void move() {
	if(dead) {
	    /* Damn, we got squashed. No more turns for us. */
	    return;
	}

	if(!age) {
	    /* First wakeup: move to phase II. */
	    age = true;
	    beasts.draw(x, y, getImage());
	    beasts.update();
	    beasts.add(this,
		       beasts.EGG_DELAY + beasts.rnd(beasts.EGG_DELAY / 2));
	} else {
	    /* Secound wakeup: hatch a beast. */
	    beasts.add(new HatchedSuperBeast(beasts, x, y),
		       beasts.EGG_HATCH_DELAY);
	}
    }

    public String toString() {
	return "Egg[" + x + ", " + y + "]";
    }
}
