package beasts;

/**
 * A scheduled event in the game, such as a <code>Beast</code> movement or
 * an <code>Egg</code> hatching.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@unsw.edu.au">peteg@unsw.edu.au</A>)
 * @version $Id: Event.java,v 1.5 2002/02/03 23:47:16 peteg Exp $
 * @see Beasts.BeastsWorld#run
 */
interface Event {
    /**
     * Note that the lock on the <code>BeastsWorld</code> object should be
     * held <b>whenever</b> this function is invoked.
     */
    void move();

    /**
     * Signal all pending events. As usual, the lock on the
     * <code>BeastsWorld</code> object should be held <b>whenever</b> this
     * function is invoked.
     */
    void signal();
}
