package beasts;

import java.awt.*;

/**
 * Immovable blocks. Can be explosive (i.e. player dies on contact,
 * <code>LightBlock</code>s are consumed if pushed into it).
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@unsw.edu.au">peteg@unsw.edu.au</A>)
 * @version $Id: HeavyBlock.java,v 1.7 2002/01/27 14:05:10 peteg Exp $
 */
class HeavyBlock extends Block {
    static Image image;

    private boolean explosive;

    HeavyBlock(BeastsWorld beasts, int x, int y, boolean explosive) {
	super(beasts, x, y);
	this.explosive = explosive;
    }

    boolean push(boolean player, int dx, int dy) {
	return false;
    }

    boolean isExplosive() {
	return explosive;
    }

    Image getImage() {
	return image;
    }

    public String toString() {
	return "HeavyBlock[" + x + ", " + y + "]" + (explosive ? "(explosive)" : "");
    }
}
