package beasts;

import java.awt.*;

/**
 * Movable blocks.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@unsw.edu.au">peteg@unsw.edu.au</A>)
 * @version $Id: LightBlock.java,v 1.7 2002/01/27 14:05:10 peteg Exp $
 */
class LightBlock extends Block {
    static Image image;

    LightBlock(BeastsWorld beasts, int x, int y) {
	super(beasts, x, y);
    }

    boolean push(boolean player, int dx, int dy) {
	WorldObject wo = beasts.getWO(x + dx, y + dy);

	if(wo == null || wo.push(player, dx, dy)) {
	    beasts.move(this, x + dx, y + dy);
	    return true;
	} else if(wo instanceof HeavyBlock
		  && ((HeavyBlock)wo).isExplosive()) {
	    /* pushed into an explosive HeavyBlock. */
	    beasts.removeWO(this);
	    return true;
	} else {
	    return false;
	}
    }

    Image getImage() {
	return image;
    }

    public String toString() {
	return "LightBlock[" + x + ", " + y + "]";
    }
}
