package beasts;

import java.awt.*;

/**
 * Abstract base class of all objects in the world.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@unsw.edu.au">peteg@unsw.edu.au</A>)
 * @version $Id: WorldObject.java,v 1.7 2002/01/27 14:05:11 peteg Exp $
 */
abstract class WorldObject {
    int x, y;
    BeastsWorld beasts;

    WorldObject(BeastsWorld beasts) {
	this.beasts = beasts;
    }

    WorldObject(BeastsWorld beasts, int x, int y) {
	this.beasts = beasts;
	this.x = x;
	this.y = y;

	beasts.draw(x, y, getImage());
    }

    /**
     * <code>Player</code> or <code>SuperBeast</code> moves in the specified
     * direction. Move all <code>LightBlock</code>s in the way, provided the
     * path is not blocked by a <code>HeavyBlock</code>, <code>Beast</code>,
     * <code>Egg</code>, etc.
     *
     * @arg player true if the <code>Player</code> is pushing.
     * @return false if the path is blocked.
     */
    abstract boolean push(boolean player, int dx, int dy);

    abstract Image getImage();

    public abstract String toString();
}
